import * as mobx from 'mobx';
const { action, observable, autorun } = mobx;

const state = observable({
  count: 0
});
// アクションじゃなくても状態の変更は可能
// 算出値、リアクションは正常に反応する
autorun(() => console.log('state.count', state.count));
state.count += 1;

// strictモードの有効化
mobx.useStrict(true);
const state2 = observable({
  count: 0
});
autorun(() => console.log('state2.count', state2.count));
// アクション外で状態を更新するとエラーを投げる
state2.count += 1;