import * as mobx from 'mobx';
const { observable, action, autorun } = mobx;

mobx.useStrict(true);

const state = observable({
  data: null
});
autorun(() => console.log(state.data));

// Promiseを返すダミーの非同期処理
const fetchServerData = () =>
  new Promise(resolve => resolve({ key: 'value' }));

// 非同期で状態を変更するアクション
const asyncAction = action(function () {
  fetchServerData().then(data => {
    // strictモードではエラーを投げる
    state.data = data;
  });
});
asyncAction();