import { observable, autorunAsync } from 'mobx';

const state = observable({ count: 0 });
// autorunと違い、状態変更が発生しないと実行されない
autorunAsync(
  // デバッグ用の名前
  'autorunAsync',
  // リアクション
  () => console.log('state.count', state.count),
  // 1000ms遅延して実行
  1000
);

state.count += 1;
state.count += 1;
// 最後の更新から1000ms後にリアクションを実行

setTimeout(() => console.log('900ms later'), 900);
setTimeout(() => console.log('1100ms later'), 1100);