import { observable, autorun, isObservable, isObservableArray, isObservableMap, isObservableObject, isBoxedObservable } from 'mobx';

console.log('array ---------');
console.log('');

// ほぼ配列として扱える
const arr = observable([]);
autorun(() => console.log('arr:', arr.join(', ')))
// 配列のメソッド
arr.push('1st');
// 要素へのアクセス・代入
arr[1] = '2nd';

console.log(Array.isArray(arr)); // => false

console.log('');
console.log('map ---------');
console.log('');

// ほぼMapとして扱える
const map = observable(new Map());
autorun(() => console.log('map.size:', map.size))
// Mapのset, has, clear ...etc
map.set('key', 'value');
console.log(map.has('key')); // => true
map.clear();

console.log(map instanceof Map); // => false

console.log('');
console.log('isObservable* ---------');
console.log('');

const arr2 = observable([]);
const map2 = observable(new Map());
const obj = observable({});
const num = observable(1);

// 以下は全てtrue
console.log(isObservable(arr2));
console.log(isObservableArray(arr2));
console.log(isObservable(map2));
console.log(isObservableMap(map2));
console.log(isObservableObject(obj));
console.log(isBoxedObservable(num));