import { observable, autorun, when, reaction } from 'mobx';

console.log('autorun -----------------');
console.log('');

const state = observable({ count: 0 });
autorun('autorun', () => console.log(state.count));
state.count += 1;

console.log('');
console.log('when -----------------');
console.log('');

const state2 = observable({ count: 0 });

when(
  // デバッグ用の名前（省略可能）
  'nameForDebug',
  // この関数がtrueを返した時にリアクションを一度だけ実行
  () => (state2.count >= 5),
  // リアクション
  () => console.log('state2.count =>', state2.count)
)
state2.count += 1; // （出力なし）
state2.count += 2; // （出力なし）
state2.count += 3; // state2.count => 6
state2.count += 4; // （出力なし）

console.log('');
console.log('reaction -----------------');
console.log('');

const state3 = observable({
  todo: [
    { title: 'task1', done: false },
    { title: 'task2', done: false }
  ]
})
reaction(
  () => state3.todo.map(task => task.title),
  titles => console.log('tasks', titles.join(', '))
);
autorun(() => console.log('autorun', state3.todo));

state3.todo.push({ title: 'task3', done: false })
state3.todo[0].done = true;
state3.todo[0].title = 'task1 neo';