import { observable, shallowObservable, autorun } from 'mobx';

console.log('obsevable ---------------------------------');

const state1 = observable({
  key1: 'val1',
  key2: {
    // key3も監視対象になる
    key3: 'val1'
  }
})
autorun(() => {
  console.log('--------------')
  console.log(state1.key1);
  console.log(state1.key2.key3);
})
state1.key1 = 'changed';      // autorunが実行される
state1.key2.key3 = 'changed'; // autorunが実行される

console.log('')
console.log('obsevable.shallowObject ---------------------------------');
console.log('')

// 第一階層のみ監視対象
const state2 = observable.shallowObject({
  key1: 'val1',
  key2: {
    // key3は監視対象にならない
    key3: 'val1'
  }
})
autorun(() => {
  console.log('--------------')
  console.log(state2.key1);
  console.log(state2.key2.key3);
})
state2.key1 = 'changed';      // autorunが実行される
state2.key2.key3 = 'changed'; // autorunが実行されない

console.log('')
console.log('@obsevable ---------------------------------');
console.log('')

class DeepState {
  @observable data = {
    key1: {
      key2: 'value'
    }
  };
}
const state3 = new DeepState();
autorun(() => {
  console.log('--------------')
  console.log(state3.data.key1.key2);
});
state3.data.key1.key2 = 'new value';

console.log('')
console.log('@obsevable.shallow ---------------------------------');
console.log('')

class State {
  @observable.shallow data = {
    key1: {
      // key2は監視されない
      key2: 'value'
    }
  };
}

const state4 = new State();
autorun(() => {
  console.log('--------------')
  console.log(state4.data.key1.key2);
});
state4.data.key1.key2 = 'new value';

