// todo-observable-2.js
import { observable, autorun } from 'mobx';

class Task {
  // MobXが変更を監視するプロパティ
  @observable text = '';
  @observable done = false;

  constructor(text) {
    this.text = text;
  }
}

class TodoStore {
  // MobXが変更を監視するプロパティ
  @observable todo = [];

  // 算出値の定義
  get countDoneTasks() {
    return this.todo.filter(task => task.done).length;
  }

  addTask(text) {
    this.todo.push(new Task(text));
  }
}

const todoStore = new TodoStore();

// リアクションの定義
autorun(() => console.log(
  '終わったタスクの数', todoStore.countDoneTasks
));

// 状態の更新
console.log('// 1回目の追加');
todoStore.addTask('洗濯する');
console.log('// 2回目の追加');
todoStore.addTask('掃除する');
console.log('// 1件目のタスクをDoneにする')
todoStore.todo[0].done = true;
