import React from 'react';
import ReactDOM from 'react-dom';
import { useStrict, observable, action } from 'mobx';
import { observer } from 'mobx-react';

// strictモードを有効化
useStrict(true);
// 状態とカウントアップするアクションを定義
const state = observable({ count: 0 });
const countUp = action(() => { state.count += 1; });

@observer
class CounterApp extends React.Component {
  render() {
    return (
      <div>
        <h1>count: {state.count}</h1>
        <button onClick={countUp}>+1</button>
      </div>
    );
  }
}

// id属性がrootである要素にCounterAppを描画
ReactDOM.render(
  <CounterApp />,
  document.getElementById('root')
);